EDIT - task #5375

cdm-server without jsvc
11/12/2015 11:02 AM - Andreas Kohlbecker

Status: In Progress Start date:

Priority: Highest Due date:

Assignee: Andreas Kohlbecker % Done: 0%
Category: cdmserver Estimated time: 0:00 hour
Target version: Reviewed Next Major Release

Severity: normal

Description

jsvc is used to start the cdm-server as daemon. Jetty 8 is however no longer using jsvc it is using the apache commons-daemon
which actually is the successor to jsvc. The commons-daemon website still suggests the usage of the native jsvc library but jetty no
longer has a package dependency to it.

jetty 8 startup command:

/usr/1lib/jvm/java-T7-openjdk-amd64/jre/bin/java -Xmx256m -Djava.awt.headless=true -Djava.io.tmpdir=
/var/cache/jetty8/data -Djava.library.path=/usr/lib -DSTART=/etc/jetty8/start.config -Djetty.home=
/usr/share/jetty8 -Djetty.logs=/var/log/jetty8 -Djetty.state=/var/lib/jetty8/jetty.state -Djetty.h
0st=0.0.0.0 -Djetty.port=8080 —-cp /usr/share/java/commons—-daemon.jar:/usr/share/jetty8/start.jar:/
usr/lib/jvm/java-T7-openjdk—-amd64/jre/lib/tools. jar org.eclipse.jetty.start.Main —--daemon etc/jetty
-logging.xml etc/jetty-started.xml

a related story on tomcat: http://blogs.mulesoft.com/dev/tomcat-tcat-server/a-better-tomcat-for-ubuntu-and-debian/

Interesting links on this topic:

e http://stackoverflow.com/questions/7687159/how-to-convert-a-java-program-to-daemon-with-jsvc
e https://stackoverflow.com/questions/28894008/what-benefit-do-i-get-from-jsvc-over-just-using-systemd
¢ https://jdebp.eu/FGA/systemd-house-of-horror/tomcat.html

Related issues:

Related to EDIT - task #6522: package cdm-server in docker container Closed
Related to EDIT - report #7898: using jstack on cdmserver with jsvc reports a... Closed
Related to EDIT - bug #5048: cdm-server causes unusual high native memory con... Closed
History

#1 - 01/13/2017 03:31 PM - Andreas Kohlbecker

- Description updated

#2 - 01/13/2017 03:31 PM - Andreas Kohlbecker

- Private changed from Yes to No

#3 - 03/17/2017 08:35 AM - Andreas Kohlbecker

- Related to task #6522: package cdm-server in docker container added

#4 - 06/20/2017 01:36 PM - Andreas Kohlbecker

- Description updated

#5 - 06/20/2017 01:55 PM - Andreas Kohlbecker

jsvc seems to cause Sigfaults in the jvm with the latest debian jessy updates, which where:

libc6-dev amd64 2.19-18+deb8u10 [2003 kB]
libc-dev-bin amd64 2.19-18+deb8u10 [238 kB]
linux-libc-dev amdé4 3.16.43-2+deb8u1 [1060 kB]
libc-bin amd64 2.19-18+deb8u10 [1281 kB]

libc6 amd64 2.19-18+deb8u10 [4665 kB]

libffi6 amd64 3.1-2+deb8u1 [20.2 kB]
linux-image-3.16.0-4-amd64 amd64 3.16.43-2+deb8u1 [33.9 MB]
multiarch-support amdé4 2.19-18+deb8u10 [181 kB]
exim4-config all 4.84.2-2+deb8u4 [502 kB]

exim4 all 4.84.2-2+deb8u4 [8584 B]

exim4-base amd64 4.84.2-2+deb8u4 [1049 kB]
exim4-daemon-light amd64 4.84.2-2+deb8u4 [632 kB]

locales all 2.19-18+deb8u10 [3930 kB]

after starting the cdm-server daemon jsvc starts up normally and subsequenlty starts the jvm process which crashes early when loading the java
runtime class libraries:

[Loaded java.lang.Character from /opt/Jjava-oracle/jdk1.8.0_131/jre/lib/rt.jar]

[Loaded java.lang.Number from /opt/java-oracle/jdk1l.8.0_131/jre/lib/rt.Jjar]

[Loaded java.lang.Float from /opt/java-oracle/jdkl1l.8.0_131/jre/lib/rt.jarl

[Loaded java.lang.Double from /opt/Jjava-oracle/jdk1.8.0_131/jre/lib/rt.jar]

[Loaded java.lang.Byte from /opt/Jjava-oracle/jdkl.8.0_131/jre/lib/rt.jar]

[Loaded java.lang.Short from /opt/java-oracle/jdk1l.8.0_131/jre/lib/rt.jarl

[Loaded java.lang.Integer from /opt/java-oracle/jdkl.8.0_131/jre/lib/rt.jar]

[Loaded java.lang.Long from /opt/Jjava-oracle/jdkl.8.0_131/jre/lib/rt.jar]

[Loaded java.lang.NullPointerException from /opt/java-oracle/jdk1l.8.0_131/jre/lib/rt.jar]
[Loaded java.lang.ArithmeticException from /opt/Jjava-oracle/jdkl.8.0_131/jre/lib/rt.jar]
Service killed by signal 11

Waiting 60 s to prevent looping

Service killed by signal 11

Service killed by signal 11

#6 - 06/20/2017 04:42 PM - Andreas Kohlbecker
- Priority changed from New to Highest
- Target version changed from Unassigned CDM tickets to Release 4.9

- Severity changed from normal to critical

#7 - 06/20/2017 04:44 PM - Andreas Kohlbecker

reverting package upgrades can easily be done by the method that | described at stack overflow:
https://superuser.com/questions/38717/how-can-i-undo-or-rollback-an-apt-get-upgrade-command-on-ubuntu/1221092#1221092

#8 - 07/21/2017 10:33 AM - Andreas Miiller

- Target version changed from Release 4.9 to Release 4.10

#9 - 09/05/2017 04:57 PM - Andreas Kohlbecker
- Description updated

#10 - 09/14/2017 12:06 PM - Andreas Kohlbecker

A potential solution for the Service killed by signal 11 problem:

https://community.ubnt.com/t5/UniFi-Routing-Switching/IMPORTANT-Debian-Ubuntu-users-MUST-READ-Updated-07-06-17/m-p/1968251#M48264

#11 - 09/15/2017 04:36 PM - Andreas Kohlbecker
- Status changed from New to In Progress
- Priority changed from Highest to Priority13

- Severity changed from critical to normal
Andreas Kohlbecker wrote:

A potential solution for the Service killed by signal 11 problem:

https://community.ubnt.com/t5/UniFi-Routing-Switching/IMPORTANT-Debian-Ubuntu-users-MUST-READ-Updated-07-06-17/m-p/1968251#M48
264

| tested a package upgrade on a clone from edit-jobber-1 by which kernel version 3.16.43-2+deb8u3 was installed. According to the above referenced
post this is exactly the version which fixed the problem with jsvc.
After installing the upgrade the cdm-server reboots normally again. Even after a full system restart everything is ok.

#12 - 09/24/2017 01:41 AM - Andreas Miiller
- Target version changed from Release 4.10 to Release 4.11

#13 - 11/08/2017 11:23 AM - Andreas Muller

- Target version changed from Release 4.11 to Release 4.12

#14 - 12/05/2017 02:05 PM - Andreas Miiller

- Target version changed from Release 4.12 to Release 4.13

#15 - 01/31/2018 12:47 PM - Andreas Miiller

- Target version changed from Release 4.13 to Release 4.14

#16 - 02/15/2018 03:36 PM - Andreas Miiller

- Target version changed from Release 4.14 to Release 5.0

#17 - 05/16/2018 11:22 AM - Andreas Kohlbecker

- Target version changed from Release 5.0 to Release 5.1

#18 - 06/28/2018 08:26 AM - Andreas Kohlbecker

- Target version changed from Release 5.1 to cdmlib - Old Next Major Release

#19 - 06/28/2018 10:05 AM - Andreas Miiller

- Target version changed from cdmlib - Old Next Major Release to Unassigned CDM tickets

next major release is not to be used anymore

#20 - 06/28/2018 10:19 AM - Andreas Kohlbecker

- Target version changed from Unassigned CDM tickets to Release 5.3

#21 - 09/06/2018 11:11 AM - Andreas Kohlbecker

- Target version changed from Release 5.3 to Release 5.4

#22 - 10/22/2018 05:20 PM - Andreas Kohlbecker

- Target version changed from Release 5.4 to Release 5.5

#23 - 11/09/2018 09:18 AM - Andreas Kohlbecker
- Related to report #7898: using jstack on cdmserver with jsvc reports all non native threads as BLOCKED added

#24 - 01/30/2019 11:45 AM - Andreas Kohlbecker

- Target version changed from Release 5.5 to Release 5.6

#25 - 02/08/2019 11:25 AM - Andreas Kohlbecker

- Related to bug #5048: cdm-server causes unusual high native memory consumption for jvm added

#26 - 02/22/2019 03:42 PM - Andreas Kohlbecker

- Target version changed from Release 5.6 to Reviewed Next Major Release

#27 - 02/22/2022 04:21 PM - Andreas Kohlbecker

for the solution fond in the jetty project, you may refer to https:/github.com/eclipse/jetty.project/issues/1485

#28 - 02/22/2022 04:23 PM - Andreas Miiller
- Priority changed from Priority13 to Highest
